---
policy: /ce/ca/azure/virtual-machine/unattached-managed-disk
logic: /ce/ca/azure/virtual-machine/unattached-managed-disk/prod.logic.yaml
executionTime: 2025-05-10T12:04:12.377872259Z
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__diskState__c') == 'Unattached'
      actual: extract('CA10__diskState__c') == 'Unattached'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 200
      actual: 200
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/azure/virtual-machine/unattached-managed-disk/policy.yaml
    md5Hash: FF59489C8B38AE9D68880FCE89814ED5
    content: "---\nnames:\n  full: \"Azure Managed Disk is not attached to any Virtual\
      \ Machine\"\n  contextual: \"Managed Disk is not attached to any Virtual Machine\"\
      \ndescription: >\n  Consider deleting or archiving a managed disk that is not\
      \ attached to \n  any virtual machine.\ncategories:\n  - \"COST\"\ntype: \"\
      COMPLIANCE_POLICY\"\nframeworkMappings:\n  - \"/frameworks/cloudaware/cost-efficiency-and-optimization/waste-reduction\"\
      \n"
  - path: /ce/ca/azure/virtual-machine/unattached-managed-disk/prod.logic.yaml
    md5Hash: 21B15C72DE318AF57F59A3C812DD165B
    content: |-
      ---
      inputType: "CA10__CaAzureManagedDisk__c"
      testData:
        - file: test-data.json
      importExtracts:
        - file: /types/CA10__CaAzureManagedDisk__c/object.extracts.yaml
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "The Managed Disk is not attached to a virtual machine."
          remediationMessage: "Consider deleting or archiving the Managed Disk."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__diskState__c"
              right:
                TEXT: "Unattached"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "The Managed Disk is attached to a virtual machine."
  - path: /ce/ca/azure/virtual-machine/unattached-managed-disk/test-data.json
    md5Hash: 868D20C093160C46E0341703646BFC81
    content: |-
      [
        {
          "expectedResult": {
            "status": "DISAPPEARED",
            "conditionIndex": "99",
            "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-03-27T10:40:33Z"
          },
          "Id": "test1",
          "CA10__disappearanceTime__c": "2025-03-20T18:36:16Z",
          "CA10__diskState__c": "Attached"
        },
        {
          "expectedResult": {
            "status": "INCOMPLIANT",
            "conditionIndex": "199",
            "conditionText": "extract('CA10__diskState__c') == 'Unattached'",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-03-27T10:40:33Z"
          },
          "Id": "test2",
          "CA10__disappearanceTime__c": null,
          "CA10__diskState__c": "Unattached"
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "200",
            "conditionText": "otherwise",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-03-27T10:40:33Z"
          },
          "Id": "test3",
          "CA10__disappearanceTime__c": null,
          "CA10__diskState__c": "Attached"
        }
      ]
  - path: /types/CA10__CaAzureManagedDisk__c/object.extracts.yaml
    md5Hash: 324855F25B28A4A6B8613A3E228EEA01
    content: "---\nextracts:\n# Values: Succeeded, Deploying, Canceled, Failed. Not\
      \ Nullable. Can't have no access, retrieved via Microsoft.Compute/disks\n  -\
      \ name: \"CA10__provisioningState__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__provisioningState__c\"\n        undeterminedIf:\n          isEmpty:\
      \ \"Corrupted data. Provisioning State cannot be empty.\"\n# Values: ActiveSAS,\
      \ ActiveSASFrozen, ActiveUpload, Attached, Frozen, ReadyToUpload, Reserved,\
      \ Unattached. Not Nullable. Can't have no access, retrieved via Microsoft.Compute/disks\n\
      \  - name: \"CA10__diskState__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__diskState__c\"\n        undeterminedIf:\n          isEmpty: \"Corrupted\
      \ data. Disk State cannot be empty.\"\n# Values: ENCRYPTIONATRESTWITHPLATFORMKEY,\
      \ ENCRYPTIONATRESTWITHCUSTOMERKEY, ENCRYPTIONATRESTWITHPLATFORMANDCUSTOMERKEYS.\n\
      \  - name: \"CA10__encryptionType__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__encryptionType__c\"\n        undeterminedIf:\n          isEmpty: \"\
      Corrupted data. Encryption Type cannot be empty.\"\n# Values: Enabled, Disabled.\
      \ Not Nullable. Can't have no access, retrieved via Microsoft.Compute/disks\n\
      \  - name: \"CA10__publicNetworkAccess__c\"\n    value: \n      FIELD:\n   \
      \     path: \"CA10__publicNetworkAccess__c\"\n        undeterminedIf:\n    \
      \      isEmpty: \"Corrupted data. Public Network Access cannot be empty.\"\n\
      # Values: AllowAll, AllowPrivate, DenyAll. Not Nullable. Can't have no access,\
      \ retrieved via Microsoft.Compute/disks\n  - name: \"CA10__networkAccessPolicy__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__networkAccessPolicy__c\"\n\
      \        undeterminedIf:\n          isEmpty: \"Corrupted data. Public Network\
      \ Access cannot be empty.\"\n# Values: AzureActiveDirectory, None. Nullable\
      \ (which equals none). Can't have no access, retrieved via Microsoft.Compute/disks\n\
      \  - name: \"CA10__dataAccessAuthMode__c\"\n    value: \n      FIELD:\n    \
      \    path: \"CA10__dataAccessAuthMode__c\"\n        \n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__diskState__c') == 'Unattached'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "200",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAzureManagedDisk__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__diskState__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-03-27T10:40:33Z")
    },
    "Id" : "test1",
    "CA10__disappearanceTime__c" : new Date("2025-03-20T18:36:16Z"),
    "CA10__diskState__c" : "Attached"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-03-27T10:40:33Z")
    },
    "Id" : "test2",
    "CA10__diskState__c" : "Unattached"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-03-27T10:40:33Z")
    },
    "Id" : "test3",
    "CA10__diskState__c" : "Attached"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAzureManagedDisk__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__diskState__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From Azure [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__diskState__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__diskState__c.isEmpty()", currentStateMessage: "Corrupted data. Disk State cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__diskState__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('Disk State [obj.CA10__diskState__c]: ' + obj.CA10__diskState__c);
      try {
          if (TextLib.equal(extract3.call(extract3), 'Unattached')) {
              return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10__diskState__c') == 'Unattached'", currentStateMessage: "The Managed Disk is not attached to a virtual machine.", currentStateReferences: references1.join('\n'), remediation: "Consider deleting or archiving the Managed Disk.", runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      return {status: 'COMPLIANT', conditionIndex: 200, conditionText: "otherwise", currentStateMessage: "The Managed Disk is attached to a virtual machine.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__diskState__c AS CA10__diskState__c,
          process_CA10__CaAzureManagedDisk__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__diskState__c AS CA10__diskState__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAzureManagedDisk__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
